=== modified file '.bzrignore'
--- .bzrignore	2014-04-02 19:55:44 +0000
+++ .bzrignore	2014-02-19 22:35:05 +0000
@@ -6,5 +6,3 @@
 project/*.net
 project/*.kicad_pcb-bak
 *.dsn
-TAGS
-.DS_Store

=== modified file 'src/rc-interface/comms.cc'
--- src/rc-interface/comms.cc	2014-03-12 23:02:38 +0000
+++ src/rc-interface/comms.cc	2014-01-22 23:54:34 +0000
@@ -43,10 +43,8 @@
 }
 
 
-void Comms::write_channels( int channel_values[] )
+static void write_raw_channel_data( int channel_values[] )
 {
-//	draw_graph( channel_values );
-
 	Serial.write( -1 );
 	Serial.write( -1 );
 	unsigned char *data = reinterpret_cast< unsigned char * >( channel_values );
@@ -54,41 +52,9 @@
 }
 
 
-bool Comms::read_channels( int channel_values[] )
+void Comms::write_channels( int channel_values[] )
 {
-	static unsigned char buf[ sizeof( int ) * ( NUM_MOTORS + 1 ) ];
-	static unsigned int buflen = 0;
-
-	bool frame_complete = false;
-
-	while( buflen < sizeof( buf ) && Serial.available() )
-	{
-		// read byte
-		buf[ buflen++ ] = Serial.read();
-
-		// check if we've got a frame
-		if( buflen > 1 &&
-			buf[ buflen - 1 ] == 0xff && buf[ buflen - 2 ] == 0xff )
-		{
-			// got a complete frame?
-			if( buflen == sizeof( buf ) ) {
-				frame_complete = true;
-
-				// copy channel values
-				unsigned char *data =
-					reinterpret_cast< unsigned char * >( channel_values );
-				memcpy( data, buf, sizeof( int ) * NUM_MOTORS );
-			}
-
-			// reset read buffer
-			buflen = 0;
-		}
-	}
-
-	// reset read buffer in the case where the buffer is full, but there's been
-	// no end-of-frame marker (i.e., bad data)
-	if( buflen >= sizeof( buf ) )
-		buflen = 0;
-
-	return frame_complete;
+	// draw_graph( channel_values );
+	write_raw_channel_data( channel_values );
 }
+

=== modified file 'src/rc-interface/comms.h'
--- src/rc-interface/comms.h	2014-02-26 22:33:50 +0000
+++ src/rc-interface/comms.h	2014-01-22 23:54:34 +0000
@@ -16,18 +16,9 @@
 	/**
 	 * Write channel values.
 	 *
-	 * @param channel_values array of NUM_CHANNELS values
+	 * @param channel_values array of values
 	 */
 	void write_channels( int channels[] );
-
-	/**
-	 * Read channel values.  Call often.  If a complete frame is read,
-	 * channel_values will contain the data.
-	 *
-	 * @param channel_values array of NUM_MOTORS values
-	 * @returns true if a whole frame was read
-	 */
-	bool read_channels( int channels[] );
 }
 
 

=== modified file 'src/rc-interface/main.ino'
--- src/rc-interface/main.ino	2014-02-26 22:33:50 +0000
+++ src/rc-interface/main.ino	2014-02-05 20:30:43 +0000
@@ -64,17 +64,8 @@
 #include "comms.h"
 
 
-void flash_led()
-{
-	static bool on = false;
-	on = !on;
-	digitalWrite( LED_PIN, on? HIGH : LOW );
-}
-
-
 void setup()
 {
-	// init subsystems
 	Receiver::setup();
 	Motors::setup();
 	Comms::setup();
@@ -84,35 +75,35 @@
 	digitalWrite( LED_PIN, LOW );
 }
 
+
+void flash_led()
+{
+	static bool on = false;
+	on = !on;
+	digitalWrite( LED_PIN, on? HIGH : LOW );
+}
+
+
 void loop()
 {
-	int motor_values[ NUM_MOTORS ];
 	int channel_values[ NUM_CHANNELS ];
 
-	// reset the motor values
-	for( int a = 0; a < NUM_MOTORS; a++ )
-		motor_values[ a ] = 0;
-
 	while( true )
 	{
 		// have we read a whole set of channel values?
 		if( Receiver::read_channels( channel_values ) )
 		{
+			// update motors
+			Motors::update();
+
 			// yes, flash led!
 			flash_led();
 
 			// send channel values to main board
 			Comms::write_channels( channel_values );
-		}
-
-		// update motors
-		Motors::update();
-
-		// read channel values from main board
-		if( Comms::read_channels( motor_values ) )
-		{
+
 			// set motor speeds
-			Motors::set_values( motor_values );
+			Motors::set_values( channel_values );
 		}
 
 		// update motors

=== modified file 'test/rc-interface/rc-interface-test'
--- test/rc-interface/rc-interface-test	2014-03-12 23:03:34 +0000
+++ test/rc-interface/rc-interface-test	2014-01-29 22:33:55 +0000
@@ -15,9 +15,6 @@
 	# number of channels to read
 	NUM_CHANNELS = 8
 
-	# number of motor channels
-	NUM_MOTORS = 4
-
 	# maximum channel value
 	MAX_CHANNEL_VALUE = 1000
 
@@ -26,28 +23,13 @@
 
 
 	def __init__( self ):
-		try:
-			self.link = serial.Serial( self.SERIAL_DEVICE, 9600 )
-			self.link_error = None
-		except serial.serialutil.SerialException as e:
-			self.link = None
-			self.link_error = e
+		self.link = serial.Serial( self.SERIAL_DEVICE, 9600 )
 		self.got_one = False
-		self.motor_values = [ 0 ] * self.NUM_MOTORS
+		self.channel_values = []
 		self.quit = False
 		self.buffer = bytearray()
 
 
-	def add_info( self, vbox, heading = False, text = '' ):
-		label = gtk.Label()
-		if( heading ):
-			label.set_markup( "<b>%s</b>" % text )
-		else:
-			label.set_label( text )
-#		label.set_justify( gtk.JUSTIFY_LEFT )
-		label.set_alignment( 0, 0 )
-		vbox.pack_start( label, False, False )
-
 	def setup_window( self ):
 
 		# create and set up window
@@ -59,98 +41,32 @@
 		self.window.set_modal( True )
 		self.window.connect( "key-press-event", self.key_press_event )
 
-		hbox = gtk.HBox( False, 10 )
-		self.window.add( hbox )
-
-		# controls frame
-		frame = gtk.Frame( "Channels" )
-		frame.set_shadow_type( gtk.SHADOW_IN )
-		hbox.pack_start( frame )
-
-		table = gtk.Table( 2, self.NUM_CHANNELS )
-		table.set_border_width( 25 )
-		table.set_row_spacings( 10 )
-		table.set_col_spacings( 15 )
-		frame.add( table )
+		# add widgets
+		table = gtk.Table( self.NUM_CHANNELS, 2 )
+		table.set_row_spacings( 20 )
+		table.set_col_spacings( 10 )
+		self.window.add( table )
 
 		# add channels
 		self.controls = []
-		for a in range( self.NUM_CHANNELS ):
+		for a in range( 0, self.NUM_CHANNELS ):
 
-			label = gtk.Label( a + 1 )
-			table.attach( label, a, a + 1, 1, 2 )
+			label = gtk.Label( "Channel %d" % ( a + 1 ) )
+			table.attach( label, 0, 1, a, a + 1 )
 
 			adj = gtk.Adjustment( 0, 0, self.MAX_CHANNEL_VALUE, 1, 0, 0 )
-			control = gtk.VScale( adj )
+			control = gtk.HScale( adj )
 			control.set_draw_value( False )
-			control.set_inverted( True )
-			control.set_size_request( -1, 200 )
+			control.set_property( 'width-request', 300 )
 			control.set_sensitive( False )
-			table.attach( control, a, a + 1, 0, 1 )
+			table.attach( control, 1, 2, a, a + 1 )
 
 			self.controls.append( control )
 
-		# motors frame
-		frame = gtk.Frame( "Motors" )
-		frame.set_shadow_type( gtk.SHADOW_IN )
-		hbox.pack_start( frame )
-
-		table = gtk.Table( 2, self.NUM_MOTORS )
-		table.set_border_width( 25 )
-		table.set_row_spacings( 10 )
-		table.set_col_spacings( 15 )
-		frame.add( table )
-
-		# add motor controls
-		self.motors = []
-		for a in range( self.NUM_MOTORS ):
-
-			label = gtk.Label( a + 1 )
-			table.attach( label, a, a + 1, 1, 2 )
-
-			adj = gtk.Adjustment( 0, 0, self.MAX_CHANNEL_VALUE, 1, 0, 0 )
-			control = gtk.VScale( adj )
-			control.set_draw_value( False )
-			control.set_inverted( True )
-			control.set_size_request( -1, 200 )
-			table.attach( control, a, a + 1, 0, 1 )
-
-			control.connect( "value-changed", self.on_motor_change, a )
-
-			self.motors.append( control )
-
-		# info frame
-		frame = gtk.Frame( "Info" )
-		hbox.pack_start( frame )
-
-		vbox = gtk.VBox()
-		vbox.set_border_width( 10 )
-		frame.add( vbox )
-
-		self.add_info( vbox, True, "USB Device:" )
-		self.add_info( vbox, False, self.SERIAL_DEVICE )
-		self.add_info( vbox )
-
-		if( self.link_error is not None ):
-			self.add_info( vbox, True, "USB Error:" )
-			label = gtk.Label( self.link_error )
-			label.set_line_wrap( True )
-			label.set_size_request( 150, -1 )
-			vbox.pack_start( label, False )
-		else:
-			pass
-
-		vbox.pack_start( gtk.Label( "" ) )
-
 		# show it
 		self.window.show_all()
 
 
-	def on_motor_change( self, widget, motor ):
-		self.motor_values[ motor ] = int( widget.get_value() )
-		self.write_serial()
-
-
 	def key_press_event( self, widget, event ):
 		if event.keyval == gtk.keysyms.Escape:
 			self.window.destroy()
@@ -163,7 +79,7 @@
 
 
 	def process_serial_data_at( self, pos ):
-		for a in range( self.NUM_CHANNELS ):
+		for a in range( 0, self.NUM_CHANNELS ):
 			at = 2 * a + pos
 			value = struct.unpack( "h", self.buffer[ at : at + 2 ] )[ 0 ]
 
@@ -173,9 +89,6 @@
 
 	def read_serial( self ):
 
-		# serial problem?
-		if self.link is None: return
-
 		# try and read
 		in_waiting = self.link.inWaiting()
 		if( in_waiting ):
@@ -204,21 +117,6 @@
 					i += 1
 
 
-	def write_serial( self ):
-
-		# serial problem?
-		if self.link is None: return
-
-		# construct message
-		bytes = bytearray()
-		bytes.extend( struct.pack( "h", -1 ) )
-		for i in range( self.NUM_MOTORS ):
-			bytes.extend( struct.pack( "h", self.motor_values[ i ] ) )
-
-		# send
-		self.link.write( bytes )
-
-
 	def main( self ):
 		self.setup_window()
 		while not self.quit:

